<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>Learning-bash</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="the-art-of-command-line">The Art of Command Line</h1>
    <p>
      <a href="https://airtable.com/shrzMhx00YiIVAWJg"
        ><img
          src="https://img.shields.io/badge/%3f-Ask%20a%20Question-ff69b4.svg"
          alt="Ask a Question"
      /></a>
    </p>
    <p>
      <a
        href="https://gitter.im/jlevy/the-art-of-command-line?utm_source=badge&amp;utm_medium=badge&amp;utm_campaign=pr-badge&amp;utm_content=badge"
        ><img
          src="https://badges.gitter.im/Join%20Chat.svg"
          alt="Join the chat at https://gitter.im/jlevy/the-art-of-command-line"
      /></a>
    </p>
    <ul>
      <li><a href="#meta">Meta</a></li>
      <li><a href="#basics">Basics</a></li>
      <li><a href="#everyday-use">Everyday use</a></li>
      <li>
        <a href="#processing-files-and-data">Processing files and data</a>
      </li>
      <li><a href="#system-debugging">System debugging</a></li>
      <li><a href="#one-liners">One-liners</a></li>
      <li><a href="#obscure-but-useful">Obscure but useful</a></li>
      <li><a href="#macos-only">macOS only</a></li>
      <li><a href="#windows-only">Windows only</a></li>
      <li><a href="#more-resources">More resources</a></li>
      <li><a href="#disclaimer">Disclaimer</a></li>
    </ul>
    <figure>
      <img
        src="cowsay.png"
        alt="curl -s ‘https://raw.githubusercontent.com/jlevy/the-art-of-command-line/master/README.md’ | egrep -o ‘\w+’ | tr -d ‘`’ | cowsay -W50"
      />
      <figcaption>
        curl -s
        ‘https://raw.githubusercontent.com/jlevy/the-art-of-command-line/master/README.md’
        | egrep -o ‘<code>\w+</code>’ | tr -d ‘`’ | cowsay -W50
      </figcaption>
    </figure>
    <p>
      Fluency on the command line is a skill often neglected or considered
      arcane, but it improves your flexibility and productivity as an engineer
      in both obvious and subtle ways. This is a selection of notes and tips on
      using the command-line that we’ve found useful when working on Linux. Some
      tips are elementary, and some are fairly specific, sophisticated, or
      obscure. This page is not long, but if you can use and recall all the
      items here, you know a lot.
    </p>
    <p>
      Some of this
      <a
        href="http://www.quora.com/What-are-some-lesser-known-but-useful-Unix-commands"
        >originally</a
      >
      <a
        href="http://www.quora.com/What-are-the-most-useful-Swiss-army-knife-one-liners-on-Unix"
        >appeared</a
      >
      on
      <a
        href="http://www.quora.com/What-are-some-time-saving-tips-that-every-Linux-user-should-know"
        >Quora</a
      >,
      <a href="https://airtable.com/shrzMhx00YiIVAWJg"
        ><strong>Please submit a question</strong></a
      >
      if you have a question related to the command line.
      <a href="/CONTRIBUTING.md"><strong>Please contribute</strong></a> if you
      see an error or something that could be better!
    </p>
    <h2 id="meta">Meta</h2>
    <p>Scope:</p>
    <ul>
      <li>
        This guide is both for beginners and the experienced. The goals are
        <em>breadth</em> (everything important), <em>specificity</em> (give
        concrete examples of the most common case), and <em>brevity</em> (avoid
        things that aren’t essential or digressions you can easily look up
        elsewhere). Every tip is essential in some situation or significantly
        saves time over alternatives.
      </li>
      <li>
        This is written for Linux, with the exception of the “<a
          href="#macos-only"
          >macOS only</a
        >” and “<a href="#windows-only">Windows only</a>” sections. Many of the
        other items apply or can be installed on other Unices or macOS (or even
        Cygwin).
      </li>
      <li>
        The focus is on interactive Bash, though many tips apply to other shells
        and to general Bash scripting.
      </li>
      <li>
        It includes both “standard” Unix commands as well as ones that require
        special package installs – so long as they are important enough to merit
        inclusion.
      </li>
    </ul>
    <p>Notes:</p>
    <ul>
      <li>
        To keep this to one page, content is implicitly included by reference.
        You’re smart enough to look up more detail elsewhere once you know the
        idea or command to Google. Use <code>apt</code>, <code>yum</code>,
        <code>dnf</code>, <code>pacman</code>, <code>pip</code> or
        <code>brew</code> (as appropriate) to install new programs.
      </li>
      <li>
        Use <a href="http://explainshell.com/">Explainshell</a> to get a helpful
        breakdown of what commands, options, pipes etc. do.
      </li>
    </ul>
    <h2 id="basics">Basics</h2>
    <ul>
      <li>
        <p>
          Learn basic Bash. Actually, type <code>man bash</code> and at least
          skim the whole thing; it’s pretty easy to follow and not that long.
          Alternate shells can be nice, but Bash is powerful and always
          available (learning <em>only</em> zsh, fish, etc., while tempting on
          your own laptop, restricts you in many situations, such as using
          existing servers).
        </p>
      </li>
      <li>
        <p>
          Learn at least one text-based editor well. The
          <code>nano</code> editor is one of the simplest for basic editing
          (opening, editing, saving, searching). However, for the power user in
          a text terminal, there is no substitute for Vim (<code>vi</code>), the
          hard-to-learn but venerable, fast, and full-featured editor. Many
          people also use the classic Emacs, particularly for larger editing
          tasks. (Of course, any modern software developer working on an
          extensive project is unlikely to use only a pure text-based editor and
          should also be familiar with modern graphical IDEs and tools.)
        </p>
      </li>
      <li>
        Finding documentation:
        <ul>
          <li>
            Know how to read official documentation with <code>man</code> (for
            the inquisitive, <code>man man</code> lists the section numbers,
            e.g. 1 is “regular” commands, 5 is files/conventions, and 8 are for
            administration). Find man pages with <code>apropos</code>.
          </li>
          <li>
            Know that some commands are not executables, but Bash builtins, and
            that you can get help on them with <code>help</code> and
            <code>help -d</code>. You can find out whether a command is an
            executable, shell builtin or an alias by using
            <code>type command</code>.
          </li>
          <li>
            <code>curl cheat.sh/command</code> will give a brief “cheat sheet”
            with common examples of how to use a shell command.
          </li>
        </ul>
      </li>
      <li>
        <p>
          Learn about redirection of output and input using
          <code>&gt;</code> and <code>&lt;</code> and pipes using
          <code>|</code>. Know <code>&gt;</code> overwrites the output file and
          <code>&gt;&gt;</code> appends. Learn about stdout and stderr.
        </p>
      </li>
      <li>
        <p>
          Learn about file glob expansion with <code>*</code> (and perhaps
          <code>?</code> and <code>[</code>…<code>]</code>) and quoting and the
          difference between double <code>"</code> and single
          <code>'</code> quotes. (See more on variable expansion below.)
        </p>
      </li>
      <li>
        <p>
          Be familiar with Bash job management: <code>&amp;</code>,
          <strong>ctrl-z</strong>, <strong>ctrl-c</strong>, <code>jobs</code>,
          <code>fg</code>, <code>bg</code>, <code>kill</code>, etc.
        </p>
      </li>
      <li>
        <p>
          Know <code>ssh</code>, and the basics of passwordless authentication,
          via <code>ssh-agent</code>, <code>ssh-add</code>, etc.
        </p>
      </li>
      <li>
        <p>
          Basic file management: <code>ls</code> and <code>ls -l</code> (in
          particular, learn what every column in <code>ls -l</code> means),
          <code>less</code>, <code>head</code>, <code>tail</code> and
          <code>tail -f</code> (or even better, <code>less +F</code>),
          <code>ln</code> and <code>ln -s</code> (learn the differences and
          advantages of hard versus soft links), <code>chown</code>,
          <code>chmod</code>, <code>du</code> (for a quick summary of disk
          usage: <code>du -hs *</code>). For filesystem management,
          <code>df</code>, <code>mount</code>, <code>fdisk</code>,
          <code>mkfs</code>, <code>lsblk</code>. Learn what an inode is (<code
            >ls -i</code
          >
          or <code>df -i</code>).
        </p>
      </li>
      <li>
        <p>
          Basic network management: <code>ip</code> or <code>ifconfig</code>,
          <code>dig</code>, <code>traceroute</code>, <code>route</code>.
        </p>
      </li>
      <li>
        <p>
          Learn and use a version control management system, such as
          <code>git</code>.
        </p>
      </li>
      <li>
        <p>
          Know regular expressions well, and the various flags to
          <code>grep</code>/<code>egrep</code>. The <code>-i</code>,
          <code>-o</code>, <code>-v</code>, <code>-A</code>, <code>-B</code>,
          and <code>-C</code> options are worth knowing.
        </p>
      </li>
      <li>
        <p>
          Learn to use <code>apt-get</code>, <code>yum</code>,
          <code>dnf</code> or <code>pacman</code> (depending on distro) to find
          and install packages. And make sure you have <code>pip</code> to
          install Python-based command-line tools (a few below are easiest to
          install via <code>pip</code>).
        </p>
      </li>
    </ul>
    <h2 id="everyday-use">Everyday use</h2>
    <ul>
      <li>
        <p>
          In Bash, use <strong>Tab</strong> to complete arguments or list all
          available commands and <strong>ctrl-r</strong> to search through
          command history (after pressing, type to search, press
          <strong>ctrl-r</strong> repeatedly to cycle through more matches,
          press <strong>Enter</strong> to execute the found command, or hit the
          right arrow to put the result in the current line to allow editing).
        </p>
      </li>
      <li>
        <p>
          In Bash, use <strong>ctrl-w</strong> to delete the last word, and
          <strong>ctrl-u</strong> to delete the content from current cursor back
          to the start of the line. Use <strong>alt-b</strong> and
          <strong>alt-f</strong> to move by word, <strong>ctrl-a</strong> to
          move cursor to beginning of line, <strong>ctrl-e</strong> to move
          cursor to end of line, <strong>ctrl-k</strong> to kill to the end of
          the line, <strong>ctrl-l</strong> to clear the screen. See
          <code>man readline</code> for all the default keybindings in Bash.
          There are a lot. For example <strong>alt-.</strong> cycles through
          previous arguments, and <strong>alt-</strong>* expands a glob.
        </p>
      </li>
      <li>
        <p>
          Alternatively, if you love vi-style key-bindings, use
          <code>set -o vi</code> (and <code>set -o emacs</code> to put it back).
        </p>
      </li>
      <li>
        <p>
          For editing long commands, after setting your editor (for example
          <code>export EDITOR=vim</code>), <strong>ctrl-x</strong>
          <strong>ctrl-e</strong> will open the current command in an editor for
          multi-line editing. Or in vi style, <strong>escape-v</strong>.
        </p>
      </li>
      <li>
        <p>
          To see recent commands, use <code>history</code>. Follow with
          <code>!n</code> (where <code>n</code> is the command number) to
          execute again. There are also many abbreviations you can use, the most
          useful probably being <code>!$</code> for last argument and
          <code>!!</code> for last command (see “HISTORY EXPANSION” in the man
          page). However, these are often easily replaced with
          <strong>ctrl-r</strong> and <strong>alt-.</strong>.
        </p>
      </li>
      <li>
        <p>
          Go to your home directory with <code>cd</code>. Access files relative
          to your home directory with the <code>~</code> prefix
          (e.g. <code>~/.bashrc</code>). In <code>sh</code> scripts refer to the
          home directory as <code>$HOME</code>.
        </p>
      </li>
      <li>
        <p>To go back to the previous working directory: <code>cd -</code>.</p>
      </li>
      <li>
        <p>
          If you are halfway through typing a command but change your mind, hit
          <strong>alt-#</strong> to add a <code>#</code> at the beginning and
          enter it as a comment (or use <strong>ctrl-a</strong>,
          <strong>#</strong>, <strong>enter</strong>). You can then return to it
          later via command history.
        </p>
      </li>
      <li>
        Use <code>xargs</code> (or <code>parallel</code>). It’s very powerful.
        Note you can control how many items execute per line (<code>-L</code>)
        as well as parallelism (<code>-P</code>). If you’re not sure if it’ll do
        the right thing, use <code>xargs echo</code> first. Also,
        <code>-I{}</code> is handy. Examples:
      </li>
    </ul>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb1-1" title="1">      <span class="fu">find</span> . -name <span class="st">&#39;*.py&#39;</span> <span class="kw">|</span> <span class="fu">xargs</span> grep some_function</a>
<a class="sourceLine" id="cb1-2" title="2">      <span class="fu">cat</span> hosts <span class="kw">|</span> <span class="fu">xargs</span> -I{} <span class="fu">ssh</span> root@{} <span class="fu">hostname</span></a></code></pre>
    </div>
    <ul>
      <li>
        <p><code>pstree -p</code> is a helpful display of the process tree.</p>
      </li>
      <li>
        <p>
          Use <code>pgrep</code> and <code>pkill</code> to find or signal
          processes by name (<code>-f</code> is helpful).
        </p>
      </li>
      <li>
        <p>
          Know the various signals you can send processes. For example, to
          suspend a process, use <code>kill -STOP [pid]</code>. For the full
          list, see <code>man 7 signal</code>
        </p>
      </li>
      <li>
        <p>
          Use <code>nohup</code> or <code>disown</code> if you want a background
          process to keep running forever.
        </p>
      </li>
      <li>
        <p>
          Check what processes are listening via <code>netstat -lntp</code> or
          <code>ss -plat</code> (for TCP; add <code>-u</code> for UDP) or
          <code>lsof -iTCP -sTCP:LISTEN -P -n</code> (which also works on
          macOS).
        </p>
      </li>
      <li>
        <p>
          See also <code>lsof</code> and <code>fuser</code> for open sockets and
          files.
        </p>
      </li>
      <li>
        <p>
          See <code>uptime</code> or <code>w</code> to know how long the system
          has been running.
        </p>
      </li>
      <li>
        <p>
          Use <code>alias</code> to create shortcuts for commonly used commands.
          For example, <code>alias ll='ls -latr'</code> creates a new alias
          <code>ll</code>.
        </p>
      </li>
      <li>
        <p>
          Save aliases, shell settings, and functions you commonly use in
          <code>~/.bashrc</code>, and
          <a href="http://superuser.com/a/183980/7106"
            >arrange for login shells to source it</a
          >. This will make your setup available in all your shell sessions.
        </p>
      </li>
      <li>
        <p>
          Put the settings of environment variables as well as commands that
          should be executed when you login in <code>~/.bash_profile</code>.
          Separate configuration will be needed for shells you launch from
          graphical environment logins and <code>cron</code> jobs.
        </p>
      </li>
      <li>
        <p>
          Synchronize your configuration files (e.g. <code>.bashrc</code> and
          <code>.bash_profile</code>) among various computers with Git.
        </p>
      </li>
      <li>
        <p>
          Understand that care is needed when variables and filenames include
          whitespace. Surround your Bash variables with quotes,
          e.g. <code>"$FOO"</code>. Prefer the <code>-0</code> or
          <code>-print0</code> options to enable null characters to delimit
          filenames, e.g. <code>locate -0 pattern | xargs -0 ls -al</code> or
          <code>find / -print0 -type d | xargs -0 ls -al</code>. To iterate on
          filenames containing whitespace in a for loop, set your IFS to be a
          newline only using <code>IFS=$'\n'</code>.
        </p>
      </li>
      <li>
        In Bash scripts, use <code>set -x</code> (or the variant
        <code>set -v</code>, which logs raw input, including unexpanded
        variables and comments) for debugging output. Use strict modes unless
        you have a good reason not to: Use <code>set -e</code> to abort on
        errors (nonzero exit code). Use <code>set -u</code> to detect unset
        variable usages. Consider <code>set -o pipefail</code> too, to abort on
        errors within pipes (though read up on it more if you do, as this topic
        is a bit subtle). For more involved scripts, also use
        <code>trap</code> on EXIT or ERR. A useful habit is to start a script
        like this, which will make it detect and abort on common errors and
        print a message:
      </li>
    </ul>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb2-1" title="1">      <span class="kw">set</span> <span class="ex">-euo</span> pipefail</a>
<a class="sourceLine" id="cb2-2" title="2">      <span class="bu">trap</span> <span class="st">&quot;echo &#39;error: Script failed: see failed command above&#39;&quot;</span> ERR</a></code></pre>
    </div>
    <ul>
      <li>
        In Bash scripts, subshells (written with parentheses) are convenient
        ways to group commands. A common example is to temporarily move to a
        different working directory, e.g.
      </li>
    </ul>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb3-1" title="1">      <span class="co"># do something in current dir</span></a>
<a class="sourceLine" id="cb3-2" title="2">      <span class="kw">(</span><span class="bu">cd</span> /some/other/dir <span class="kw">&amp;&amp;</span> <span class="ex">other-command</span><span class="kw">)</span></a>
<a class="sourceLine" id="cb3-3" title="3">      <span class="co"># continue in original dir</span></a></code></pre>
    </div>
    <ul>
      <li>
        <p>
          In Bash, note there are lots of kinds of variable expansion. Checking
          a variable exists: <code>${name:?error message}</code>. For example,
          if a Bash script requires a single argument, just write
          <code>input_file=${1:?usage: $0 input_file}</code>. Using a default
          value if a variable is empty: <code>${name:-default}</code>. If you
          want to have an additional (optional) parameter added to the previous
          example, you can use something like
          <code>output_file=${2:-logfile}</code>. If <code>$2</code> is omitted
          and thus empty, <code>output_file</code> will be set to
          <code>logfile</code>. Arithmetic expansion:
          <code>i=$(( (i + 1) % 5 ))</code>. Sequences: <code>{1..10}</code>.
          Trimming of strings: <code>${var%suffix}</code> and
          <code>${var#prefix}</code>. For example if <code>var=foo.pdf</code>,
          then <code>echo ${var%.pdf}.txt</code> prints <code>foo.txt</code>.
        </p>
      </li>
      <li>
        <p>
          Brace expansion using <code>{</code>…<code>}</code> can reduce having
          to re-type similar text and automate combinations of items. This is
          helpful in examples like <code>mv foo.{txt,pdf} some-dir</code> (which
          moves both files), <code>cp somefile{,.bak}</code> (which expands to
          <code>cp somefile somefile.bak</code>) or
          <code>mkdir -p test-{a,b,c}/subtest-{1,2,3}</code> (which expands all
          possible combinations and creates a directory tree). Brace expansion
          is performed before any other expansion.
        </p>
      </li>
      <li>
        <p>
          The order of expansions is: brace expansion; tilde expansion,
          parameter and variable expansion, arithmetic expansion, and command
          substitution (done in a left-to-right fashion); word splitting; and
          filename expansion. (For example, a range like
          <code>{1..20}</code> cannot be expressed with variables using
          <code>{$a..$b}</code>. Use <code>seq</code> or a <code>for</code> loop
          instead, e.g., <code>seq $a $b</code> or
          <code>for((i=a; i&lt;=b; i++)); do ... ; done</code>.)
        </p>
      </li>
      <li>
        The output of a command can be treated like a file via
        <code>&lt;(some command)</code> (known as process substitution). For
        example, compare local <code>/etc/hosts</code> with a remote one:
      </li>
    </ul>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb4-1" title="1">      <span class="fu">diff</span> /etc/hosts <span class="op">&lt;(</span><span class="fu">ssh</span> somehost cat /etc/hosts<span class="op">)</span></a></code></pre>
    </div>
    <ul>
      <li>
        When writing scripts you may want to put all of your code in curly
        braces. If the closing brace is missing, your script will be prevented
        from executing due to a syntax error. This makes sense when your script
        is going to be downloaded from the web, since it prevents partially
        downloaded scripts from executing:
      </li>
    </ul>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">      <span class="co"># Your code here</span></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="kw">}</span></a></code></pre>
    </div>
    <ul>
      <li>
        A “here document” allows
        <a href="https://www.tldp.org/LDP/abs/html/here-docs.html"
          >redirection of multiple lines of input</a
        >
        as if from a file:
      </li>
    </ul>
    <pre><code>cat &lt;&lt;EOF
input
on multiple lines
EOF</code></pre>
    <ul>
      <li>
        <p>
          In Bash, redirect both standard output and standard error via:
          <code>some-command &gt;logfile 2&gt;&amp;1</code> or
          <code>some-command &amp;&gt;logfile</code>. Often, to ensure a command
          does not leave an open file handle to standard input, tying it to the
          terminal you are in, it is also good practice to add
          <code>&lt;/dev/null</code>.
        </p>
      </li>
      <li>
        <p>
          Use <code>man ascii</code> for a good ASCII table, with hex and
          decimal values. For general encoding info, <code>man unicode</code>,
          <code>man utf-8</code>, and <code>man latin1</code> are helpful.
        </p>
      </li>
      <li>
        <p>
          Use <code>screen</code> or
          <a href="https://tmux.github.io/"><code>tmux</code></a> to multiplex
          the screen, especially useful on remote ssh sessions and to detach and
          re-attach to a session. <code>byobu</code> can enhance screen or tmux
          by providing more information and easier management. A more minimal
          alternative for session persistence only is
          <a href="https://github.com/bogner/dtach"><code>dtach</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          In ssh, knowing how to port tunnel with <code>-L</code> or
          <code>-D</code> (and occasionally <code>-R</code>) is useful, e.g. to
          access web sites from a remote server.
        </p>
      </li>
      <li>
        It can be useful to make a few optimizations to your ssh configuration;
        for example, this <code>~/.ssh/config</code> contains settings to avoid
        dropped connections in certain network environments, uses compression
        (which is helpful with scp over low-bandwidth connections), and
        multiplex channels to the same server with a local control file:
      </li>
    </ul>
    <pre><code>      TCPKeepAlive=yes
      ServerAliveInterval=15
      ServerAliveCountMax=6
      Compression=yes
      ControlMaster auto
      ControlPath /tmp/%r@%h:%p
      ControlPersist yes</code></pre>
    <ul>
      <li>
        <p>
          A few other options relevant to ssh are security sensitive and should
          be enabled with care, e.g. per subnet or host or in trusted networks:
          <code>StrictHostKeyChecking=no</code>, <code>ForwardAgent=yes</code>
        </p>
      </li>
      <li>
        <p>
          Consider <a href="https://mosh.mit.edu/"><code>mosh</code></a> an
          alternative to ssh that uses UDP, avoiding dropped connections and
          adding convenience on the road (requires server-side setup).
        </p>
      </li>
      <li>
        To get the permissions on a file in octal form, which is useful for
        system configuration but not available in <code>ls</code> and easy to
        bungle, use something like
      </li>
    </ul>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb8-1" title="1">      <span class="fu">stat</span> -c <span class="st">&#39;%A %a %n&#39;</span> /etc/timezone</a></code></pre>
    </div>
    <ul>
      <li>
        <p>
          For interactive selection of values from the output of another
          command, use
          <a href="https://github.com/mooz/percol"><code>percol</code></a> or
          <a href="https://github.com/junegunn/fzf"><code>fzf</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          For interaction with files based on the output of another command
          (like <code>git</code>), use <code>fpp</code> (<a
            href="https://github.com/facebook/PathPicker"
            >PathPicker</a
          >).
        </p>
      </li>
      <li>
        <p>
          For a simple web server for all files in the current directory (and
          subdirs), available to anyone on your network, use:
          <code>python -m SimpleHTTPServer 7777</code> (for port 7777 and Python
          2) and <code>python -m http.server 7777</code> (for port 7777 and
          Python 3).
        </p>
      </li>
      <li>
        <p>
          For running a command as another user, use <code>sudo</code>. Defaults
          to running as root; use <code>-u</code> to specify another user. Use
          <code>-i</code> to login as that user (you will be asked for
          <em>your</em> password).
        </p>
      </li>
      <li>
        <p>
          For switching the shell to another user, use
          <code>su username</code> or <code>su - username</code>. The latter
          with “-” gets an environment as if another user just logged in.
          Omitting the username defaults to root. You will be asked for the
          password <em>of the user you are switching to</em>.
        </p>
      </li>
      <li>
        <p>
          Know about the
          <a
            href="https://wiki.debian.org/CommonErrorMessages/ArgumentListTooLong"
            >128K limit</a
          >
          on command lines. This “Argument list too long” error is common when
          wildcard matching large numbers of files. (When this happens
          alternatives like <code>find</code> and <code>xargs</code> may help.)
        </p>
      </li>
      <li>
        For a basic calculator (and of course access to Python in general), use
        the <code>python</code> interpreter. For example,
      </li>
    </ul>
    <pre><code>&gt;&gt;&gt; 2+3
5</code></pre>
    <h2 id="processing-files-and-data">Processing files and data</h2>
    <ul>
      <li>
        <p>
          To locate a file by name in the current directory,
          <code>find . -iname '*something*'</code> (or similar). To find a file
          anywhere by name, use <code>locate something</code> (but bear in mind
          <code>updatedb</code> may not have indexed recently created files).
        </p>
      </li>
      <li>
        <p>
          For general searching through source or data files, there are several
          options more advanced or faster than <code>grep -r</code>, including
          (in rough order from older to newer)
          <a href="https://github.com/beyondgrep/ack2"><code>ack</code></a
          >,
          <a href="https://github.com/ggreer/the_silver_searcher"
            ><code>ag</code></a
          >
          (“the silver searcher”), and
          <a href="https://github.com/BurntSushi/ripgrep"><code>rg</code></a>
          (ripgrep).
        </p>
      </li>
      <li>
        <p>To convert HTML to text: <code>lynx -dump -stdin</code></p>
      </li>
      <li>
        <p>
          For Markdown, HTML, and all kinds of document conversion, try
          <a href="http://pandoc.org/"><code>pandoc</code></a
          >. For example, to convert a Markdown document to Word format:
          <code>pandoc README.md --from markdown --to docx -o temp.docx</code>
        </p>
      </li>
      <li>
        <p>If you must handle XML, <code>xmlstarlet</code> is old but good.</p>
      </li>
      <li>
        <p>
          For JSON, use
          <a href="http://stedolan.github.io/jq/"><code>jq</code></a
          >. For interactive use, also see
          <a href="https://github.com/simeji/jid"><code>jid</code></a> and
          <a href="https://github.com/fiatjaf/jiq"><code>jiq</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          For YAML, use
          <a href="https://github.com/0k/shyaml"><code>shyaml</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          For Excel or CSV files,
          <a href="https://github.com/onyxfish/csvkit">csvkit</a> provides
          <code>in2csv</code>, <code>csvcut</code>, <code>csvjoin</code>,
          <code>csvgrep</code>, etc.
        </p>
      </li>
      <li>
        <p>
          For Amazon S3,
          <a href="https://github.com/s3tools/s3cmd"><code>s3cmd</code></a> is
          convenient and
          <a href="https://github.com/bloomreach/s4cmd"><code>s4cmd</code></a>
          is faster. Amazon’s
          <a href="https://github.com/aws/aws-cli"><code>aws</code></a> and the
          improved
          <a href="https://github.com/donnemartin/saws"><code>saws</code></a>
          are essential for other AWS-related tasks.
        </p>
      </li>
      <li>
        <p>
          Know about <code>sort</code> and <code>uniq</code>, including uniq’s
          <code>-u</code> and <code>-d</code> options – see one-liners below.
          See also <code>comm</code>.
        </p>
      </li>
      <li>
        <p>
          Know about <code>cut</code>, <code>paste</code>, and
          <code>join</code> to manipulate text files. Many people use
          <code>cut</code> but forget about <code>join</code>.
        </p>
      </li>
      <li>
        <p>
          Know about <code>wc</code> to count newlines (<code>-l</code>),
          characters (<code>-m</code>), words (<code>-w</code>) and bytes
          (<code>-c</code>).
        </p>
      </li>
      <li>
        <p>
          Know about <code>tee</code> to copy from stdin to a file and also to
          stdout, as in <code>ls -al | tee file.txt</code>.
        </p>
      </li>
      <li>
        <p>
          For more complex calculations, including grouping, reversing fields,
          and statistical calculations, consider
          <a href="https://www.gnu.org/software/datamash/"
            ><code>datamash</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          Know that locale affects a lot of command line tools in subtle ways,
          including sorting order (collation) and performance. Most Linux
          installations will set <code>LANG</code> or other locale variables to
          a local setting like US English. But be aware sorting will change if
          you change locale. And know i18n routines can make sort or other
          commands run <em>many times</em> slower. In some situations (such as
          the set operations or uniqueness operations below) you can safely
          ignore slow i18n routines entirely and use traditional byte-based sort
          order, using <code>export LC_ALL=C</code>.
        </p>
      </li>
      <li>
        <p>
          You can set a specific command’s environment by prefixing its
          invocation with the environment variable settings, as in
          <code>TZ=Pacific/Fiji date</code>.
        </p>
      </li>
      <li>
        <p>
          Know basic <code>awk</code> and <code>sed</code> for simple data
          munging. See <a href="#one-liners">One-liners</a> for examples.
        </p>
      </li>
      <li>
        To replace all occurrences of a string in place, in one or more files:
      </li>
    </ul>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb10-1" title="1">      <span class="fu">perl</span> -pi.bak -e <span class="st">&#39;s/old-string/new-string/g&#39;</span> my-files-*.txt</a></code></pre>
    </div>
    <ul>
      <li>
        To rename multiple files and/or search and replace within files, try
        <a href="https://github.com/jlevy/repren"><code>repren</code></a
        >. (In some cases the <code>rename</code> command also allows multiple
        renames, but be careful as its functionality is not the same on all
        Linux distributions.)
      </li>
    </ul>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb11-1" title="1">      <span class="co"># Full rename of filenames, directories, and contents foo -&gt; bar:</span></a>
<a class="sourceLine" id="cb11-2" title="2">      <span class="ex">repren</span> --full --preserve-case --from foo --to bar .</a>
<a class="sourceLine" id="cb11-3" title="3">      <span class="co"># Recover backup files whatever.bak -&gt; whatever:</span></a>
<a class="sourceLine" id="cb11-4" title="4">      <span class="ex">repren</span> --renames --from <span class="st">&#39;(.*)\.bak&#39;</span> --to <span class="st">&#39;\1&#39;</span> *.bak</a>
<a class="sourceLine" id="cb11-5" title="5">      <span class="co"># Same as above, using rename, if available:</span></a>
<a class="sourceLine" id="cb11-6" title="6">      <span class="ex">rename</span> <span class="st">&#39;s/\.bak$//&#39;</span> *.bak</a></code></pre>
    </div>
    <ul>
      <li>
        As the man page says, <code>rsync</code> really is a fast and
        extraordinarily versatile file copying tool. It’s known for
        synchronizing between machines but is equally useful locally. When
        security restrictions allow, using <code>rsync</code> instead of
        <code>scp</code> allows recovery of a transfer without restarting from
        scratch. It also is among the
        <a
          href="https://web.archive.org/web/20130929001850/http://linuxnote.net/jianingy/en/linux/a-fast-way-to-remove-huge-number-of-files.html"
          >fastest ways</a
        >
        to delete large numbers of files:
      </li>
    </ul>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb12-1" title="1"><span class="fu">mkdir</span> empty <span class="kw">&amp;&amp;</span> <span class="fu">rsync</span> -r --delete empty/ some-dir <span class="kw">&amp;&amp;</span> <span class="fu">rmdir</span> some-dir</a></code></pre>
    </div>
    <ul>
      <li>
        <p>
          For monitoring progress when processing files, use
          <a href="http://www.ivarch.com/programs/pv.shtml"><code>pv</code></a
          >, <a href="https://github.com/dmerejkowsky/pycp"><code>pycp</code></a
          >,
          <a href="https://github.com/dspinellis/pmonitor"
            ><code>pmonitor</code></a
          >,
          <a href="https://github.com/Xfennec/progress"><code>progress</code></a
          >, <code>rsync --progress</code>, or, for block-level copying,
          <code>dd status=progress</code>.
        </p>
      </li>
      <li>
        <p>
          Use <code>shuf</code> to shuffle or select random lines from a file.
        </p>
      </li>
      <li>
        <p>
          Know <code>sort</code>’s options. For numbers, use <code>-n</code>, or
          <code>-h</code> for handling human-readable numbers (e.g. from
          <code>du -h</code>). Know how keys work (<code>-t</code> and
          <code>-k</code>). In particular, watch out that you need to write
          <code>-k1,1</code> to sort by only the first field;
          <code>-k1</code> means sort according to the whole line. Stable sort
          (<code>sort -s</code>) can be useful. For example, to sort first by
          field 2, then secondarily by field 1, you can use
          <code>sort -k1,1 | sort -s -k2,2</code>.
        </p>
      </li>
      <li>
        <p>
          If you ever need to write a tab literal in a command line in Bash
          (e.g. for the -t argument to sort), press <strong>ctrl-v</strong>
          <strong>[Tab]</strong> or write <code>$'\t'</code> (the latter is
          better as you can copy/paste it).
        </p>
      </li>
      <li>
        <p>
          The standard tools for patching source code are <code>diff</code> and
          <code>patch</code>. See also <code>diffstat</code> for summary
          statistics of a diff and <code>sdiff</code> for a side-by-side diff.
          Note <code>diff -r</code> works for entire directories. Use
          <code>diff -r tree1 tree2 | diffstat</code> for a summary of changes.
          Use <code>vimdiff</code> to compare and edit files.
        </p>
      </li>
      <li>
        <p>
          For binary files, use <code>hd</code>, <code>hexdump</code> or
          <code>xxd</code> for simple hex dumps and <code>bvi</code>,
          <code>hexedit</code> or <code>biew</code> for binary editing.
        </p>
      </li>
      <li>
        <p>
          Also for binary files, <code>strings</code> (plus <code>grep</code>,
          etc.) lets you find bits of text.
        </p>
      </li>
      <li>
        <p>For binary diffs (delta compression), use <code>xdelta3</code>.</p>
      </li>
      <li>
        To convert text encodings, try <code>iconv</code>. Or
        <code>uconv</code> for more advanced use; it supports some advanced
        Unicode things. For example:
      </li>
    </ul>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb13-1" title="1">      <span class="co"># Displays hex codes or actual names of characters (useful for debugging):</span></a>
<a class="sourceLine" id="cb13-2" title="2">      <span class="ex">uconv</span> -f utf-8 -t utf-8 -x <span class="st">&#39;::Any-Hex;&#39;</span> <span class="op">&lt;</span> input.txt</a>
<a class="sourceLine" id="cb13-3" title="3">      <span class="ex">uconv</span> -f utf-8 -t utf-8 -x <span class="st">&#39;::Any-Name;&#39;</span> <span class="op">&lt;</span> input.txt</a>
<a class="sourceLine" id="cb13-4" title="4">      <span class="co"># Lowercase and removes all accents (by expanding and dropping them):</span></a>
<a class="sourceLine" id="cb13-5" title="5">      <span class="ex">uconv</span> -f utf-8 -t utf-8 -x <span class="st">&#39;::Any-Lower; ::Any-NFD; [:Nonspacing Mark:] &gt;; ::Any-NFC;&#39;</span> <span class="op">&lt;</span> input.txt <span class="op">&gt;</span> output.txt</a></code></pre>
    </div>
    <ul>
      <li>
        <p>
          To split files into pieces, see <code>split</code> (to split by size)
          and <code>csplit</code> (to split by a pattern).
        </p>
      </li>
      <li>
        <p>
          Date and time: To get the current date and time in the helpful
          <a href="https://en.wikipedia.org/wiki/ISO_8601">ISO 8601</a> format,
          use <code>date -u +"%Y-%m-%dT%H:%M:%SZ"</code> (other options
          <a
            href="https://stackoverflow.com/questions/7216358/date-command-on-os-x-doesnt-have-iso-8601-i-option"
            >are</a
          >
          <a
            href="https://unix.stackexchange.com/questions/164826/date-command-iso-8601-option"
            >problematic</a
          >). To manipulate date and time expressions, use <code>dateadd</code>,
          <code>datediff</code>, <code>strptime</code> etc. from
          <a href="http://www.fresse.org/dateutils/"><code>dateutils</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          Use <code>zless</code>, <code>zmore</code>, <code>zcat</code>, and
          <code>zgrep</code> to operate on compressed files.
        </p>
      </li>
      <li>
        <p>
          File attributes are settable via <code>chattr</code> and offer a
          lower-level alternative to file permissions. For example, to protect
          against accidental file deletion the immutable flag:
          <code>sudo chattr +i /critical/directory/or/file</code>
        </p>
      </li>
      <li>
        Use <code>getfacl</code> and <code>setfacl</code> to save and restore
        file permissions. For example:
      </li>
    </ul>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb14-1" title="1">   <span class="ex">getfacl</span> -R /some/path <span class="op">&gt;</span> permissions.txt</a>
<a class="sourceLine" id="cb14-2" title="2">   <span class="ex">setfacl</span> --restore=permissions.txt</a></code></pre>
    </div>
    <ul>
      <li>
        To create empty files quickly, use <code>truncate</code> (creates
        <a href="https://en.wikipedia.org/wiki/Sparse_file">sparse file</a>),
        <code>fallocate</code> (ext4, xfs, btrfs and ocfs2 filesystems),
        <code>xfs_mkfile</code> (almost any filesystems, comes in xfsprogs
        package), <code>mkfile</code> (for Unix-like systems like Solaris, Mac
        OS).
      </li>
    </ul>
    <h2 id="system-debugging">System debugging</h2>
    <ul>
      <li>
        <p>
          For web debugging, <code>curl</code> and <code>curl -I</code> are
          handy, or their <code>wget</code> equivalents, or the more modern
          <a href="https://github.com/jkbrzt/httpie"><code>httpie</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          To know current cpu/disk status, the classic tools are
          <code>top</code> (or the better <code>htop</code>),
          <code>iostat</code>, and <code>iotop</code>. Use
          <code>iostat -mxz 15</code> for basic CPU and detailed per-partition
          disk stats and performance insight.
        </p>
      </li>
      <li>
        <p>
          For network connection details, use <code>netstat</code> and
          <code>ss</code>.
        </p>
      </li>
      <li>
        <p>
          For a quick overview of what’s happening on a system,
          <code>dstat</code> is especially useful. For broadest overview with
          details, use
          <a href="https://github.com/nicolargo/glances"><code>glances</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          To know memory status, run and understand the output of
          <code>free</code> and <code>vmstat</code>. In particular, be aware the
          “cached” value is memory held by the Linux kernel as file cache, so
          effectively counts toward the “free” value.
        </p>
      </li>
      <li>
        <p>
          Java system debugging is a different kettle of fish, but a simple
          trick on Oracle’s and some other JVMs is that you can run
          <code>kill -3 &lt;pid&gt;</code> and a full stack trace and heap
          summary (including generational garbage collection details, which can
          be highly informative) will be dumped to stderr/logs. The JDK’s
          <code>jps</code>, <code>jstat</code>, <code>jstack</code>,
          <code>jmap</code> are useful.
          <a href="https://github.com/aragozin/jvm-tools">SJK tools</a> are more
          advanced.
        </p>
      </li>
      <li>
        <p>
          Use <a href="http://www.bitwizard.nl/mtr/"><code>mtr</code></a> as a
          better traceroute, to identify network issues.
        </p>
      </li>
      <li>
        <p>
          For looking at why a disk is full,
          <a href="https://dev.yorhel.nl/ncdu"><code>ncdu</code></a> saves time
          over the usual commands like <code>du -sh *</code>.
        </p>
      </li>
      <li>
        <p>
          To find which socket or process is using bandwidth, try
          <a href="http://www.ex-parrot.com/~pdw/iftop/"><code>iftop</code></a>
          or <a href="https://github.com/raboof/nethogs"><code>nethogs</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          The <code>ab</code> tool (comes with Apache) is helpful for
          quick-and-dirty checking of web server performance. For more complex
          load testing, try <code>siege</code>.
        </p>
      </li>
      <li>
        <p>
          For more serious network debugging,
          <a href="https://wireshark.org/"><code>wireshark</code></a
          >,
          <a
            href="https://www.wireshark.org/docs/wsug_html_chunked/AppToolstshark.html"
            ><code>tshark</code></a
          >, or <a href="http://ngrep.sourceforge.net/"><code>ngrep</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          Know about <code>strace</code> and <code>ltrace</code>. These can be
          helpful if a program is failing, hanging, or crashing, and you don’t
          know why, or if you want to get a general idea of performance. Note
          the profiling option (<code>-c</code>), and the ability to attach to a
          running process (<code>-p</code>). Use trace child option
          (<code>-f</code>) to avoid missing important calls.
        </p>
      </li>
      <li>
        <p>
          Know about <code>ldd</code> to check shared libraries etc — but
          <a href="http://www.catonmat.net/blog/ldd-arbitrary-code-execution/"
            >never run it on untrusted files</a
          >.
        </p>
      </li>
      <li>
        <p>
          Know how to connect to a running process with <code>gdb</code> and get
          its stack traces.
        </p>
      </li>
      <li>
        <p>
          Use <code>/proc</code>. It’s amazingly helpful sometimes when
          debugging live problems. Examples: <code>/proc/cpuinfo</code>,
          <code>/proc/meminfo</code>, <code>/proc/cmdline</code>,
          <code>/proc/xxx/cwd</code>, <code>/proc/xxx/exe</code>,
          <code>/proc/xxx/fd/</code>, <code>/proc/xxx/smaps</code> (where
          <code>xxx</code> is the process id or pid).
        </p>
      </li>
      <li>
        <p>
          When debugging why something went wrong in the past,
          <a href="http://sebastien.godard.pagesperso-orange.fr/"
            ><code>sar</code></a
          >
          can be very helpful. It shows historic statistics on CPU, memory,
          network, etc.
        </p>
      </li>
      <li>
        <p>
          For deeper systems and performance analyses, look at
          <code>stap</code> (<a href="https://sourceware.org/systemtap/wiki"
            >SystemTap</a
          >),
          <a href="https://en.wikipedia.org/wiki/Perf_%28Linux%29"
            ><code>perf</code></a
          >, and
          <a href="https://github.com/draios/sysdig"><code>sysdig</code></a
          >.
        </p>
      </li>
      <li>
        <p>
          Check what OS you’re on with <code>uname</code> or
          <code>uname -a</code> (general Unix/kernel info) or
          <code>lsb_release -a</code> (Linux distro info).
        </p>
      </li>
      <li>
        <p>
          Use <code>dmesg</code> whenever something’s acting really funny (it
          could be hardware or driver issues).
        </p>
      </li>
      <li>
        <p>
          If you delete a file and it doesn’t free up expected disk space as
          reported by <code>du</code>, check whether the file is in use by a
          process:
          <code>lsof | grep deleted | grep "filename-of-my-big-file"</code>
        </p>
      </li>
    </ul>
    <h2 id="one-liners">One-liners</h2>
    <p>A few examples of piecing together commands:</p>
    <ul>
      <li>
        It is remarkably helpful sometimes that you can do set intersection,
        union, and difference of text files via
        <code>sort</code>/<code>uniq</code>. Suppose <code>a</code> and
        <code>b</code> are text files that are already uniqued. This is fast,
        and works on files of arbitrary size, up to many gigabytes. (Sort is not
        limited by memory, though you may need to use the <code>-T</code> option
        if <code>/tmp</code> is on a small root partition.) See also the note
        about <code>LC_ALL</code> above and <code>sort</code>’s
        <code>-u</code> option (left out for clarity below).
      </li>
    </ul>
    <div class="sourceCode" id="cb15">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb15-1" title="1">      <span class="fu">sort</span> a b <span class="kw">|</span> <span class="fu">uniq</span> <span class="op">&gt;</span> c   <span class="co"># c is a union b</span></a>
<a class="sourceLine" id="cb15-2" title="2">      <span class="fu">sort</span> a b <span class="kw">|</span> <span class="fu">uniq</span> -d <span class="op">&gt;</span> c   <span class="co"># c is a intersect b</span></a>
<a class="sourceLine" id="cb15-3" title="3">      <span class="fu">sort</span> a b b <span class="kw">|</span> <span class="fu">uniq</span> -u <span class="op">&gt;</span> c   <span class="co"># c is set difference a - b</span></a></code></pre>
    </div>
    <ul>
      <li>
        <p>
          Use <code>grep . *</code> to quickly examine the contents of all files
          in a directory (so each line is paired with the filename), or
          <code>head -100 *</code> (so each file has a heading). This can be
          useful for directories filled with config settings like those in
          <code>/sys</code>, <code>/proc</code>, <code>/etc</code>.
        </p>
      </li>
      <li>
        Summing all numbers in the third column of a text file (this is probably
        3X faster and 3X less code than equivalent Python):
      </li>
    </ul>
    <div class="sourceCode" id="cb16">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb16-1" title="1">      <span class="fu">awk</span> <span class="st">&#39;{ x += $3 } END { print x }&#39;</span> myfile</a></code></pre>
    </div>
    <ul>
      <li>
        To see sizes/dates on a tree of files, this is like a recursive
        <code>ls -l</code> but is easier to read than <code>ls -lR</code>:
      </li>
    </ul>
    <div class="sourceCode" id="cb17">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb17-1" title="1">      <span class="fu">find</span> . -type f -ls</a></code></pre>
    </div>
    <ul>
      <li>
        Say you have a text file, like a web server log, and a certain value
        that appears on some lines, such as an <code>acct_id</code> parameter
        that is present in the URL. If you want a tally of how many requests for
        each <code>acct_id</code>:
      </li>
    </ul>
    <div class="sourceCode" id="cb18">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb18-1" title="1">      <span class="fu">egrep</span> -o <span class="st">&#39;acct_id=[0-9]+&#39;</span> access.log <span class="kw">|</span> <span class="fu">cut</span> -d= -f2 <span class="kw">|</span> <span class="fu">sort</span> <span class="kw">|</span> <span class="fu">uniq</span> -c <span class="kw">|</span> <span class="fu">sort</span> -rn</a></code></pre>
    </div>
    <ul>
      <li>
        <p>
          To continuously monitor changes, use <code>watch</code>, e.g. check
          changes to files in a directory with
          <code>watch -d -n 2 'ls -rtlh | tail'</code> or to network settings
          while troubleshooting your wifi settings with
          <code>watch -d -n 2 ifconfig</code>.
        </p>
      </li>
      <li>
        Run this function to get a random tip from this document (parses
        Markdown and extracts an item):
      </li>
    </ul>
    <div class="sourceCode" id="cb19">
      <pre
        class="sourceCode sh"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb19-1" title="1">      <span class="kw">function</span><span class="fu"> taocl()</span> <span class="kw">{</span></a>
<a class="sourceLine" id="cb19-2" title="2">        <span class="ex">curl</span> -s https://raw.githubusercontent.com/jlevy/the-art-of-command-line/master/README.md <span class="kw">|</span></a>
<a class="sourceLine" id="cb19-3" title="3">          <span class="fu">sed</span> <span class="st">&#39;/cowsay[.]png/d&#39;</span> <span class="kw">|</span></a>
<a class="sourceLine" id="cb19-4" title="4">          <span class="ex">pandoc</span> -f markdown -t html <span class="kw">|</span></a>
<a class="sourceLine" id="cb19-5" title="5">          <span class="ex">xmlstarlet</span> fo --html --dropdtd <span class="kw">|</span></a>
<a class="sourceLine" id="cb19-6" title="6">          <span class="ex">xmlstarlet</span> sel -t -v <span class="st">&quot;(html/body/ul/li[count(p)&gt;0])[</span><span class="va">$RANDOM</span><span class="st"> mod last()+1]&quot;</span> <span class="kw">|</span></a>
<a class="sourceLine" id="cb19-7" title="7">          <span class="ex">xmlstarlet</span> unesc <span class="kw">|</span> <span class="fu">fmt</span> -80 <span class="kw">|</span> <span class="ex">iconv</span> -t US</a>
<a class="sourceLine" id="cb19-8" title="8">      <span class="kw">}</span></a></code></pre>
    </div>
    <h2 id="obscure-but-useful">Obscure but useful</h2>
    <ul>
      <li>
        <p>
          <code>expr</code>: perform arithmetic or boolean operations or
          evaluate regular expressions
        </p>
      </li>
      <li>
        <p><code>m4</code>: simple macro processor</p>
      </li>
      <li>
        <p><code>yes</code>: print a string a lot</p>
      </li>
      <li>
        <p><code>cal</code>: nice calendar</p>
      </li>
      <li>
        <p><code>env</code>: run a command (useful in scripts)</p>
      </li>
      <li>
        <p>
          <code>printenv</code>: print out environment variables (useful in
          debugging and scripts)
        </p>
      </li>
      <li>
        <p>
          <code>look</code>: find English words (or lines in a file) beginning
          with a string
        </p>
      </li>
      <li>
        <p>
          <code>cut</code>, <code>paste</code> and <code>join</code>: data
          manipulation
        </p>
      </li>
      <li>
        <p><code>fmt</code>: format text paragraphs</p>
      </li>
      <li>
        <p><code>pr</code>: format text into pages/columns</p>
      </li>
      <li>
        <p><code>fold</code>: wrap lines of text</p>
      </li>
      <li>
        <p>
          <code>column</code>: format text fields into aligned, fixed-width
          columns or tables
        </p>
      </li>
      <li>
        <p>
          <code>expand</code> and <code>unexpand</code>: convert between tabs
          and spaces
        </p>
      </li>
      <li>
        <p><code>nl</code>: add line numbers</p>
      </li>
      <li>
        <p><code>seq</code>: print numbers</p>
      </li>
      <li>
        <p><code>bc</code>: calculator</p>
      </li>
      <li>
        <p><code>factor</code>: factor integers</p>
      </li>
      <li>
        <p>
          <a href="https://gnupg.org/"><code>gpg</code></a
          >: encrypt and sign files
        </p>
      </li>
      <li>
        <p><code>toe</code>: table of terminfo entries</p>
      </li>
      <li>
        <p><code>nc</code>: network debugging and data transfer</p>
      </li>
      <li>
        <p>
          <code>socat</code>: socket relay and tcp port forwarder (similar to
          <code>netcat</code>)
        </p>
      </li>
      <li>
        <p>
          <a href="https://github.com/mattthias/slurm"><code>slurm</code></a
          >: network traffic visualization
        </p>
      </li>
      <li>
        <p><code>dd</code>: moving data between files or devices</p>
      </li>
      <li>
        <p><code>file</code>: identify type of a file</p>
      </li>
      <li>
        <p>
          <code>tree</code>: display directories and subdirectories as a nesting
          tree; like <code>ls</code> but recursive
        </p>
      </li>
      <li>
        <p><code>stat</code>: file info</p>
      </li>
      <li>
        <p><code>time</code>: execute and time a command</p>
      </li>
      <li>
        <p>
          <code>timeout</code>: execute a command for specified amount of time
          and stop the process when the specified amount of time completes.
        </p>
      </li>
      <li>
        <p>
          <code>lockfile</code>: create semaphore file that can only be removed
          by <code>rm -f</code>
        </p>
      </li>
      <li>
        <p><code>logrotate</code>: rotate, compress and mail logs.</p>
      </li>
      <li>
        <p>
          <code>watch</code>: run a command repeatedly, showing results and/or
          highlighting changes
        </p>
      </li>
      <li>
        <p>
          <a href="https://github.com/joh/when-changed"
            ><code>when-changed</code></a
          >: runs any command you specify whenever it sees file changed. See
          <code>inotifywait</code> and <code>entr</code> as well.
        </p>
      </li>
      <li>
        <p><code>tac</code>: print files in reverse</p>
      </li>
      <li>
        <p><code>comm</code>: compare sorted files line by line</p>
      </li>
      <li>
        <p><code>strings</code>: extract text from binary files</p>
      </li>
      <li>
        <p><code>tr</code>: character translation or manipulation</p>
      </li>
      <li>
        <p>
          <code>iconv</code> or <code>uconv</code>: conversion for text
          encodings
        </p>
      </li>
      <li>
        <p><code>split</code> and <code>csplit</code>: splitting files</p>
      </li>
      <li>
        <p>
          <code>sponge</code>: read all input before writing it, useful for
          reading from then writing to the same file, e.g.,
          <code>grep -v something some-file | sponge some-file</code>
        </p>
      </li>
      <li>
        <p>
          <code>units</code>: unit conversions and calculations; converts
          furlongs per fortnight to twips per blink (see also
          <code>/usr/share/units/definitions.units</code>)
        </p>
      </li>
      <li>
        <p><code>apg</code>: generates random passwords</p>
      </li>
      <li>
        <p><code>xz</code>: high-ratio file compression</p>
      </li>
      <li>
        <p><code>ldd</code>: dynamic library info</p>
      </li>
      <li>
        <p><code>nm</code>: symbols from object files</p>
      </li>
      <li>
        <p>
          <code>ab</code> or
          <a href="https://github.com/wg/wrk"><code>wrk</code></a
          >: benchmarking web servers
        </p>
      </li>
      <li>
        <p><code>strace</code>: system call debugging</p>
      </li>
      <li>
        <p>
          <a href="http://www.bitwizard.nl/mtr/"><code>mtr</code></a
          >: better traceroute for network debugging
        </p>
      </li>
      <li>
        <p><code>cssh</code>: visual concurrent shell</p>
      </li>
      <li>
        <p>
          <code>rsync</code>: sync files and folders over SSH or in local file
          system
        </p>
      </li>
      <li>
        <p>
          <a href="https://wireshark.org/"><code>wireshark</code></a> and
          <a
            href="https://www.wireshark.org/docs/wsug_html_chunked/AppToolstshark.html"
            ><code>tshark</code></a
          >: packet capture and network debugging
        </p>
      </li>
      <li>
        <p>
          <a href="http://ngrep.sourceforge.net/"><code>ngrep</code></a
          >: grep for the network layer
        </p>
      </li>
      <li>
        <p><code>host</code> and <code>dig</code>: DNS lookups</p>
      </li>
      <li>
        <p><code>lsof</code>: process file descriptor and socket info</p>
      </li>
      <li>
        <p><code>dstat</code>: useful system stats</p>
      </li>
      <li>
        <p>
          <a href="https://github.com/nicolargo/glances"><code>glances</code></a
          >: high level, multi-subsystem overview
        </p>
      </li>
      <li>
        <p><code>iostat</code>: Disk usage stats</p>
      </li>
      <li>
        <p><code>mpstat</code>: CPU usage stats</p>
      </li>
      <li>
        <p><code>vmstat</code>: Memory usage stats</p>
      </li>
      <li>
        <p><code>htop</code>: improved version of top</p>
      </li>
      <li>
        <p><code>last</code>: login history</p>
      </li>
      <li>
        <p><code>w</code>: who’s logged on</p>
      </li>
      <li>
        <p><code>id</code>: user/group identity info</p>
      </li>
      <li>
        <p>
          <a href="http://sebastien.godard.pagesperso-orange.fr/"
            ><code>sar</code></a
          >: historic system stats
        </p>
      </li>
      <li>
        <p>
          <a href="http://www.ex-parrot.com/~pdw/iftop/"><code>iftop</code></a>
          or <a href="https://github.com/raboof/nethogs"><code>nethogs</code></a
          >: network utilization by socket or process
        </p>
      </li>
      <li>
        <p><code>ss</code>: socket statistics</p>
      </li>
      <li>
        <p><code>dmesg</code>: boot and system error messages</p>
      </li>
      <li>
        <p>
          <code>sysctl</code>: view and configure Linux kernel parameters at run
          time
        </p>
      </li>
      <li>
        <p><code>hdparm</code>: SATA/ATA disk manipulation/performance</p>
      </li>
      <li>
        <p>
          <code>lsblk</code>: list block devices: a tree view of your disks and
          disk partitions
        </p>
      </li>
      <li>
        <p>
          <code>lshw</code>, <code>lscpu</code>, <code>lspci</code>,
          <code>lsusb</code>, <code>dmidecode</code>: hardware information,
          including CPU, BIOS, RAID, graphics, devices, etc.
        </p>
      </li>
      <li>
        <p>
          <code>lsmod</code> and <code>modinfo</code>: List and show details of
          kernel modules.
        </p>
      </li>
      <li>
        <p>
          <code>fortune</code>, <code>ddate</code>, and <code>sl</code>: um,
          well, it depends on whether you consider steam locomotives and Zippy
          quotations “useful”
        </p>
      </li>
    </ul>
    <h2 id="macos-only">macOS only</h2>
    <p>These are items relevant <em>only</em> on macOS.</p>
    <ul>
      <li>
        <p>
          Package management with <code>brew</code> (Homebrew) and/or
          <code>port</code> (MacPorts). These can be used to install on macOS
          many of the above commands.
        </p>
      </li>
      <li>
        <p>
          Copy output of any command to a desktop app with
          <code>pbcopy</code> and paste input from one with
          <code>pbpaste</code>.
        </p>
      </li>
      <li>
        <p>
          To enable the Option key in macOS Terminal as an alt key (such as used
          in the commands above like <strong>alt-b</strong>,
          <strong>alt-f</strong>, etc.), open Preferences -&gt; Profiles -&gt;
          Keyboard and select “Use Option as Meta key”.
        </p>
      </li>
      <li>
        <p>
          To open a file with a desktop app, use <code>open</code> or
          <code>open -a /Applications/Whatever.app</code>.
        </p>
      </li>
      <li>
        <p>
          Spotlight: Search files with <code>mdfind</code> and list metadata
          (such as photo EXIF info) with <code>mdls</code>.
        </p>
      </li>
      <li>
        <p>
          Be aware macOS is based on BSD Unix, and many commands (for example
          <code>ps</code>, <code>ls</code>, <code>tail</code>, <code>awk</code>,
          <code>sed</code>) have many subtle variations from Linux, which is
          largely influenced by System V-style Unix and GNU tools. You can often
          tell the difference by noting a man page has the heading “BSD General
          Commands Manual.” In some cases GNU versions can be installed, too
          (such as <code>gawk</code> and <code>gsed</code> for GNU awk and sed).
          If writing cross-platform Bash scripts, avoid such commands (for
          example, consider Python or <code>perl</code>) or test carefully.
        </p>
      </li>
      <li>
        <p>To get macOS release information, use <code>sw_vers</code>.</p>
      </li>
    </ul>
    <h2 id="windows-only">Windows only</h2>
    <p>These items are relevant <em>only</em> on Windows.</p>
    <h3 id="ways-to-obtain-unix-tools-under-windows">
      Ways to obtain Unix tools under Windows
    </h3>
    <ul>
      <li>
        <p>
          Access the power of the Unix shell under Microsoft Windows by
          installing <a href="https://cygwin.com/">Cygwin</a>. Most of the
          things described in this document will work out of the box.
        </p>
      </li>
      <li>
        <p>
          On Windows 10, you can use
          <a href="https://msdn.microsoft.com/commandline/wsl/about"
            >Windows Subsystem for Linux (WSL)</a
          >, which provides a familiar Bash environment with Unix command line
          utilities.
        </p>
      </li>
      <li>
        <p>
          If you mainly want to use GNU developer tools (such as GCC) on
          Windows, consider <a href="http://www.mingw.org/">MinGW</a> and its
          <a href="http://www.mingw.org/wiki/msys">MSYS</a> package, which
          provides utilities such as bash, gawk, make and grep. MSYS doesn’t
          have all the features compared to Cygwin. MinGW is particularly useful
          for creating native Windows ports of Unix tools.
        </p>
      </li>
      <li>
        <p>
          Another option to get Unix look and feel under Windows is
          <a href="https://github.com/dthree/cash">Cash</a>. Note that only very
          few Unix commands and command-line options are available in this
          environment.
        </p>
      </li>
    </ul>
    <h3 id="useful-windows-command-line-tools">
      Useful Windows command-line tools
    </h3>
    <ul>
      <li>
        <p>
          You can perform and script most Windows system administration tasks
          from the command line by learning and using <code>wmic</code>.
        </p>
      </li>
      <li>
        <p>
          Native command-line Windows networking tools you may find useful
          include <code>ping</code>, <code>ipconfig</code>,
          <code>tracert</code>, and <code>netstat</code>.
        </p>
      </li>
      <li>
        <p>
          You can perform
          <a
            href="http://www.thewindowsclub.com/rundll32-shortcut-commands-windows"
            >many useful Windows tasks</a
          >
          by invoking the <code>Rundll32</code> command.
        </p>
      </li>
    </ul>
    <h3 id="cygwin-tips-and-tricks">Cygwin tips and tricks</h3>
    <ul>
      <li>
        <p>
          Install additional Unix programs with the Cygwin’s package manager.
        </p>
      </li>
      <li>
        <p>Use <code>mintty</code> as your command-line window.</p>
      </li>
      <li>
        <p>Access the Windows clipboard through <code>/dev/clipboard</code>.</p>
      </li>
      <li>
        <p>
          Run <code>cygstart</code> to open an arbitrary file through its
          registered application.
        </p>
      </li>
      <li>
        <p>Access the Windows registry with <code>regtool</code>.</p>
      </li>
      <li>
        <p>
          Note that a <code>C:\</code> Windows drive path becomes
          <code>/cygdrive/c</code> under Cygwin, and that Cygwin’s
          <code>/</code> appears under <code>C:\cygwin</code> on Windows.
          Convert between Cygwin and Windows-style file paths with
          <code>cygpath</code>. This is most useful in scripts that invoke
          Windows programs.
        </p>
      </li>
    </ul>
    <h2 id="more-resources">More resources</h2>
    <ul>
      <li>
        <a href="https://github.com/alebcay/awesome-shell">awesome-shell</a>: A
        curated list of shell tools and resources.
      </li>
      <li>
        <a href="https://github.com/herrbischoff/awesome-osx-command-line"
          >awesome-osx-command-line</a
        >: A more in-depth guide for the macOS command line.
      </li>
      <li>
        <a href="http://redsymbol.net/articles/unofficial-bash-strict-mode/"
          >Strict mode</a
        >
        for writing better shell scripts.
      </li>
      <li>
        <a href="https://github.com/koalaman/shellcheck">shellcheck</a>: A shell
        script static analysis tool. Essentially, lint for bash/sh/zsh.
      </li>
      <li>
        <a href="http://www.dwheeler.com/essays/filenames-in-shell.html"
          >Filenames and Pathnames in Shell</a
        >: The sadly complex minutiae on how to handle filenames correctly in
        shell scripts.
      </li>
      <li>
        <a href="http://datascienceatthecommandline.com/#tools"
          >Data Science at the Command Line</a
        >: More commands and tools helpful for doing data science, from the book
        of the same name
      </li>
    </ul>
    <h2 id="disclaimer">Disclaimer</h2>
    <p>
      With the exception of very small tasks, code is written so others can read
      it. With power comes responsibility. The fact you <em>can</em> do
      something in Bash doesn’t necessarily mean you should! ;)
    </p>
    <h2 id="license">License</h2>
    <p>
      <a href="http://creativecommons.org/licenses/by-sa/4.0/"
        ><img
          src="https://i.creativecommons.org/l/by-sa/4.0/88x31.png"
          alt="Creative Commons License"
      /></a>
    </p>
    <p>
      This work is licensed under a
      <a href="http://creativecommons.org/licenses/by-sa/4.0/"
        >Creative Commons Attribution-ShareAlike 4.0 International License</a
      >. I
    </p>
  </body>
</html>
